@ECHO OFF
CLS

:CHECK-ADMIN
NET SESSION > NUL 2>&1
IF %ERRORLEVEL% NEQ 0 GOTO RESTART-WITH-ADMIN

:CONTINUE
CLS
ECHO.
ECHO.
ECHO  ***********************************
ECHO  ***   Ontkoppel schoolaccount   ***
ECHO  ***********************************
ECHO.
ECHO  Met dit script kun je een persoonlijke account maken en je schoolaccount verwijderen van deze laptop
ECHO.
ECHO  Hierna kun je niet meer bij de bestanden die in de huidige account zijn opgeslagen, zoals de bestanden 
ECHO  in de folders: Afbeeldingen, Bureaublad, Documenten, Downloads, Muziek en Videos. Geinstalleerde 
ECHO  apps zullen niet verwijderd worden. Wel wordt de licentie van school voor Office 365 ingetrokken
ECHO.
ECHO  Let op! Mocht je bestanden willen behouden, sla deze dan op voordat je verdergaat. De Scholengroep LingeRijn 
ECHO  is niet verantwoordelijk voor eventueel verlies van gegevens
ECHO.
ECHO.
ECHO.
ECHO  Wil je verdergaan met het verwijderen van je schoolaccount?
ECHO.
ECHO  Kies [J/N]:

CHOICE /C JN /N > NUL 2>&1
SET CHOICE=%ERRORLEVEL%

IF "%CHOICE%" == "1" GOTO CHECK-INTERNET
IF "%CHOICE%" == "2" GOTO ABORT
GOTO EXIT

:CHECK-INTERNET
PING -n 1 -w 1000 8.8.8.8 >NUL 2>&1
IF %ERRORLEVEL% NEQ 0 GOTO ERROR-NO-INTERNET

:SET-USER
SET LocalUser=
CLS
ECHO.
ECHO.
<NUL SET /P="X Voer de gewenste naam van de nieuwe Windows account in: "
SET /P LocalUser=

:CHECK-USER
IF "%LocalUser%" == "" GOTO WARNING-USER-EMPTY
ECHO %LocalUser%| FINDSTR /L "~ ! @ # $ %% ^ & * ( ) + = [ ] { } \ / ? , . ; :" >NUL && (GOTO WARNING-USER-INVALID)
GOTO SET-PASSWORD

:WARNING-USER-EMPTY
ECHO.
ECHO.
ECHO  Let op! De gebruikersnaam mag niet leeg zijn
ECHO.
ECHO  Druk op een toets om verder te gaan ...
PAUSE > NUL
GOTO SET-USER

:WARNING-USER-INVALID
ECHO.
ECHO.
ECHO  Let op! De gebruikersnaam mag alleen de volgende tekens bevatten: a-z, A-Z, 0-9 en -
ECHO.
ECHO  Druk op een toets om verder te gaan ...
PAUSE > NUL
GOTO SET-USER

:SET-PASSWORD
SET LocalPass=
CLS
ECHO.
ECHO.

<NUL SET /P="X Voer het gewenste wachtwoord in: "
SET /P LocalPass=

:CHECK-PASSWORD
IF "%LocalPass%" == "" GOTO WARNING-PASSWORD-EMPTY
GOTO CREDENTIALS-VERIFY

:WARNING-PASSWORD-EMPTY
ECHO.
ECHO.
ECHO  Let op! Het wachtwoord mag niet leeg zijn
ECHO.
ECHO  Druk op een toets om verder te gaan ...
PAUSE > NUL
GOTO SET-PASSWORD

:CREDENTIALS-VERIFY
CLS
ECHO.
ECHO.
ECHO  Er wordt een Windows account gemaakt met de volgende gegevens:
ECHO.
ECHO  Gebruikersnaam: ... %LocalUser%
ECHO  Wachtwoord: ....... %LocalPass%
ECHO.
ECHO.
ECHO.
ECHO  Zijn deze gegevens juist? [J/N]:

:CREDENTIALS-CHECK
CHOICE /C JN /N > NUL 2>&1
SET CHOICE=%ERRORLEVEL%

IF "%CHOICE%" == "1" GOTO ACCOUNT-CREATE-WARNING
IF "%CHOICE%" == "2" GOTO SET-USER
GOTO EXIT

:ACCOUNT-CREATE-WARNING
CLS
ECHO.
ECHO.
ECHO  Er wordt een Windows account gemaakt met de volgende gegevens:
ECHO.
ECHO  Gebruikersnaam: ... %LocalUser%
ECHO  Wachtwoord: ....... %LocalPass%
ECHO.
ECHO.
ECHO.
ECHO  Belangrijk! Schrijf deze gegevens op voordat je verdergaat
ECHO  Deze zijn nodig om straks in te kunnen loggen op jouw laptop
ECHO.
ECHO  Druk op een toets om verder te gaan ...
PAUSE > NUL

:ACCOUNT-CREATE
NET USER %LocalUser% %LocalPass% /ADD > NUL
IF %ERRORLEVEL% NEQ 0 (
	GOTO ACCOUNT-CREATE-RETRY
) ELSE (
	GOTO CHECK-ACCOUNT-CREATE
)

:CHECK-ACCOUNT-CREATE
ECHO.
ECHO.
NET USER | FINDSTR "%LocalUser%" > NUL
IF %ERRORLEVEL% == 0 (
	GOTO ACCOUNT-CREATED
) ELSE (
	GOTO ACCOUNT-CREATE-RETRY
)

:ACCOUNT-CREATE-RETRY
CLS
ECHO.
ECHO.
ECHO  Het maken van account %LocalUser% is mislukt
ECHO.
ECHO.
ECHO  Wil je het nogmaals proberen? [J/N]:

CHOICE /C JN /N > NUL 2>&1
SET CHOICE=%ERRORLEVEL%

IF "%CHOICE%" == "1" GOTO SET-USER
IF "%CHOICE%" == "2" GOTO HELPDESK
GOTO EXIT

:ACCOUNT-CREATED
CLS
ECHO.
ECHO.
ECHO  De account: %LocalUser% is aangemaakt

:MAKE-ACCOUNT-ADMIN
NET LOCALGROUP Administrators %LocalUser% /ADD > NUL
IF %ERRORLEVEL% NEQ 0 GOTO ERROR-NO-ADMIN

:DISCONNECT-FROM-ENTRA
ECHO.
ECHO.
ECHO  De schoolaccount wordt verwijderd ...
ECHO.
ECHO.

DSREGCMD /LEAVE
IF %ERRORLEVEL% NEQ 0 GOTO ERROR-DISCONNECT-FROM-ENTRA

:REBOOT-PROMPT
CLS
ECHO.
ECHO.
ECHO  De schoolaccount is verwijderd
ECHO.
ECHO  De nieuwe persoonlijke Windows account voor deze laptop is:
ECHO.
ECHO  Gebruikersnaam: ... %LocalUser%
ECHO  Wachtwoord: ....... %LocalPass%
ECHO.
ECHO  Mocht je dit nog niet gedaan hebben, schrijf deze gegevens dan nu op
ECHO.
ECHO.
ECHO  Wil je de laptop nu herstarten met de nieuwe account? [J/N]:

CHOICE /C JN /N > NUL 2>&1
SET CHOICE=%ERRORLEVEL%

IF "%CHOICE%" == "1" GOTO REBOOT
IF "%CHOICE%" == "2" GOTO REBOOT-NO
GOTO EXIT

:RESTART-WITH-ADMIN
ECHO.
ECHO.
ECHO  Dit script dient te worden uitgevoerd met administrator rechten
ECHO.
ECHO  Windows zal nu toestemming vragen om dit script wijzigingen uit te laten voeren op de laptop
ECHO.
ECHO  Druk op een toets om verder te gaan ...	
PAUSE > NUL
POWERSHELL -Command "Start-Process '%~f0' -Verb RunAs"
EXIT

:REBOOT
CLS
ECHO.
ECHO.
ECHO  De laptop zal over 5 seconden herstarten ...
ECHO.
ECHO.
SHUTDOWN /R /T 5
PAUSE > NUL

:REBOOT-NO
CLS
ECHO.
ECHO.
ECHO  Vergeet niet om de laptop te herstarten, zodat je de nieuwe account kunt gebruiken
ECHO.
ECHO.
GOTO EXIT

:ERROR-NO-INTERNET
CLS
ECHO.
ECHO.
ECHO  Het lijkt erop dat de laptop niet verbonden is met het internet
ECHO.
ECHO  Voor het ontkoppelen van de schoolaccount is een internetverbinding vereist
ECHO.
ECHO  Zorg dat de laptop beschikt over een werkende wifi of bekabelde verbinding
ECHO.
ECHO.
GOTO EXIT

:ERROR-NO-ADMIN
CLS
ECHO.
ECHO.
ECHO  Kon gebruiker %LocalUser% geen administrator rechten geven
ECHO.
ECHO  Neem contact op met de helpdesk van de school
ECHO.
ECHO.
GOTO EXIT

:ERROR-DISCONNECT-FROM-ENTRA
CLS
ECHO.
ECHO.
ECHO  De schoolaccount kon niet verwijderd worden
ECHO.
ECHO  Neem contact op met de helpdesk van de school
ECHO.
ECHO.
GOTO EXIT

:HELPDESK
CLS
ECHO.
ECHO.
ECHO  Neem contact op met de helpdesk van de school
ECHO.
ECHO.
GOTO EXIT

:ABORT
CLS
ECHO.
ECHO.
ECHO  Het script is afgebroken
ECHO.
ECHO.
GOTO EXIT

:EXIT
ECHO  Druk op een toets om dit venster te sluiten ...
PAUSE > NUL
EXIT /B